// This is a C program for ID3 Inducer, used by ID3Builder. To compile
//   this, you would need to get MLC++ library from SGI.
//
// The program takes the (absolute) path and name of the dataset file
// (there has to exist .names and .data files) as the first argument, 
// and the name of the output file as second argument


#include <basics.h>     // Must be included first in any program using MLC++
#include <ID3Inducer.h> // Include ID3Inducer class declarations
#include <mlcIO.h>
#include <MLCStream.h>

main(int argc, char * const * argv)
{
   ID3Inducer inducer("Ibiza");      // "inducer" is an object of ID3Inducer.
                                    // The argument is the "description."
   inducer.set_unknown_edges(FALSE);// Avoid edges for "unknown" attributes.

   inducer.read_data(argv[1]);   // Read data files <filename>.names and  
                                    //   <filename>tutorial.data 
   inducer.train();                 // Produce categorizer
   // inducer.display_struct();        // Display structure of categorizer

   MString outputFile = argv[2];
   MLCOStream outputStream(outputFile);

   inducer.display_struct(outputStream, DisplayPref::ASCIIDisplay);   
   
   outputStream.close();

   return 0;                        // Return success to shell
}   
